/**
 * Copyright (c) 2012 Barco n.v. All Rights Reserved. This software is confidential and proprietary information of Barco n.v. ("Confidential
 * Information"). You shall not disclose such Confidential Information and shall use it only in accordance with the terms of the license agreement you
 * entered into with Barco.
 */
package com.jms.sample;


import java.util.HashMap;
import java.util.LinkedList;
import java.util.Queue;
import java.util.concurrent.ConcurrentLinkedQueue;

import javax.jms.JMSException;
import javax.jms.Message;
import javax.jms.MessageListener;
import javax.jms.TextMessage;


/**
 * TODO: Documentation to be done for type 'MsgListener'..
 * 
 * @author vibh
 */
public class MsgListener
    implements MessageListener
{
    private Object mSyncMap = new Object();
    private final Queue<Integer> mEventQ = new ConcurrentLinkedQueue<Integer>();
    
    private final String mSeparator = ";";
    
    boolean mNoteTime = false;
    HashMap<Integer, Long> mMapTimestamp = new HashMap<Integer, Long>();
    
    private synchronized void EnableTimer(boolean arg)
    {
        mNoteTime = arg;            
    }
    
    private synchronized boolean IsTimerActive()
    {
        return mNoteTime;            
    }

    private MyThread mThread =null;

    /**
     * TODO: Documentation to be done for constructor 'MsgListener', by 'vibh'..
     */
    public MsgListener()
    {
        // TODO Auto-generated constructor stub
        mThread = new MyThread();
        (new Thread(mThread)).start();
    }

    public void showResult()
    {
        // TODO Auto-generated constructor stub
        mThread.flush();
    }
    
    public void startTimer()
    {
        // TODO Auto-generated constructor stub
        EnableTimer(true);
    }
    
    public void stopTimer()
    {
        // TODO Auto-generated constructor stub
        EnableTimer(false);
    }
    
    public long GetMessageArrivalTime(Integer number)
    {
        Long t;
        
        synchronized (mSyncMap)
        {
            t = mMapTimestamp.get(number);
            if (t == null)
                return -1;
            else
                mMapTimestamp.clear();                
        }
        
        return t.longValue(); 
    }

    /**
     * @see javax.jms.MessageListener#onMessage(javax.jms.Message)
     */
    @Override
    public void onMessage (Message anArg0)
    {
        try
        {
            // System.out.println(((TextMessage) anArg0).getText());
            String[] arrStr = ((TextMessage) anArg0).getText().split(mSeparator);            

            Integer eventNumber = Integer.parseInt(arrStr[0]);
            mEventQ.add(eventNumber);
            
            System.out.println(eventNumber + " , " + arrStr[1].length());
            
            if(IsTimerActive())
            {
                synchronized (mSyncMap)
                {
                    mMapTimestamp.put(eventNumber, System.currentTimeMillis());                    
                }                
            }
        }
        catch (JMSException anException)
        {
            // TODO Auto-generated catch block
            anException.printStackTrace();
        }
        catch (Exception anException)
        {
            // TODO Auto-generated catch block
            anException.printStackTrace();
        }
    }


    private class MyThread
        implements Runnable
    {
        LinkedList<Integer> MissedEvents = new LinkedList<Integer>();
        HashMap<Integer, Integer> LastEventperSession = new HashMap<Integer, Integer>();
        Integer MaxEvent = 0;
        Integer EventsOutofSequence = 0;
        Integer SameSessionEventsOutofSequence = 0;
        




        private void displayStatus ()
        {
            System.out.println("-----------------------");
            System.out.println("EventNumber reached = " + MaxEvent);
            System.out.println("Number of Missed-Events = " + MissedEvents.size());
            System.out.println("Number of Events-Out-Of-Sequence = " + EventsOutofSequence);
            System.out.println("Number of Events-Out-Of-Sequence from same JMS-Session= " + SameSessionEventsOutofSequence);
            System.out.println();
        }
        
        public void flush ()
        {
            System.out.println("-----------------------");
            System.out.println("EventNumber reached = " + MaxEvent);
            System.out.println("Number of Missed-Events = " + MissedEvents.size());
            System.out.println("Number of Events-Out-Of-Sequence = " + EventsOutofSequence);
            System.out.println("Number of Events-Out-Of-Sequence from same JMS-Session= " + SameSessionEventsOutofSequence);
            System.out.println();
            System.out.println("----------Missed-Events-------------");
            for(Integer i : MissedEvents)
            {
                System.out.println(i);                
            }           
        }


        /**
         * @see java.lang.Runnable#run()
         */
        @Override
        public void run ()
        {
            System.out.println("started.");

            while (true)
            {
                boolean show = false;
                Integer number;
                // number = eventQ.poll();
                // if (number != null)
                if (!mEventQ.isEmpty())
                {
                    number = mEventQ.remove();
                    //System.out.println(number);

                    if (MaxEvent == 0)
                    {
                        MaxEvent = number;
                        continue;
                    }
                    if (number == 1)
                    {
                        MaxEvent = number;
                        // MissedEvents.clear();
                        // EventsOutofSequence = 0;
                    }

                    if (number < MaxEvent)
                    {
                        EventsOutofSequence++;
                        MissedEvents.remove(number);
                        show = true;
                    }
                    else
                    {
                        if (number - MaxEvent > 1)
                        {
                            for (int i = MaxEvent + 1; i < number; i++)
                            {
                                MissedEvents.add(i);
                            }
                            show = true;
                        }
                        MaxEvent = number;
                    }

                    // check if out of sequence for same JMS-session
                    Integer lastnum = LastEventperSession.get(number / 100);
                    if (lastnum != null && number < lastnum)
                    {
                        SameSessionEventsOutofSequence++;
                        System.out.println("LastNum from same Session= " + lastnum + "CurrentNum= " + number);
                        show = true;
                    }
                    LastEventperSession.put(number / 100, number);
                    if (number % 100 == 99)
                    {
                        LastEventperSession.remove(number / 100);
                    }
                    
                    
                    if (show)
                    {
                        show = false;
                        displayStatus();
                    }
                }
                else
                {
                    try
                    {

                        Thread.currentThread().sleep(1000);
                    }
                    catch (InterruptedException anException)
                    {
                        anException.printStackTrace();
                    }
                }
            }
        }
    }
}
