/**
 * Copyright (c) 2012 Barco n.v. All Rights Reserved. This software is confidential and proprietary information of Barco n.v. ("Confidential
 * Information"). You shall not disclose such Confidential Information and shall use it only in accordance with the terms of the license agreement you
 * entered into with Barco.
 */
package com.jms.sample;


import java.util.LinkedList;
import java.util.List;

import javax.ejb.Stateless;
import javax.jms.Connection;
import javax.jms.ConnectionFactory;
import javax.jms.JMSException;
import javax.jms.Message;
import javax.jms.MessageProducer;
import javax.jms.Session;
import javax.jms.Topic;
import javax.naming.InitialContext;


/**
 * TODO: Documentation to be done for type 'MyBean'..
 * 
 * @author vibh
 */

@Stateless
public class MyBean
    implements IMyBean
{
    private static int mEventNumber = 0;

    private static Connection mConnection = null;
    private static Session mSession = null;
    private static MessageProducer mPublisher = null;

    private static Object mSyncSend = new Object();

    private static synchronized int getEventNumber ()
    {
        return ++mEventNumber;
    }

    private synchronized void CreateInstance ()
    {
        if (mSession != null)
            return;
        
        try
        {
            InitialContext ic = new InitialContext();

            ConnectionFactory cf = (ConnectionFactory) ic.lookup("java:/JmsXA");
            Topic topic = (Topic) ic.lookup("topic/MyTopic");

            mConnection = cf.createConnection();
            //mSession = mConnection.createSession(true, Session.SESSION_TRANSACTED);
            mSession = mConnection.createSession(false, Session.AUTO_ACKNOWLEDGE);
            mPublisher = mSession.createProducer(topic);

            mConnection.start();
        }
        catch (Exception anException)
        {
            anException.printStackTrace();
        }
    }


    private synchronized int SendMessage (int PayloadInBytes)
    {
        Integer num = 0;

        String payload = "";        
        for(int i=0; i<PayloadInBytes; i++)
        {
            payload += "Z";            
        }
        
        synchronized (mSyncSend)
        {
            try
            {
                num = getEventNumber();
                num = num * 100;
                for (int i = 0; i < 100; i++)
                {
                    // if(i==95)
                    // {
                    // num++;
                    // SendMessage(num.toString());
                    // num--;
                    // }
                    
                    //Message msg = mSession.createTextMessage(num.toString());
                    Message msg = mSession.createTextMessage(num.toString()+ ";" + payload);

                    mPublisher.send(msg);
                    // SendMessage(num.toString());
                    num++;
                }
                num--;
                //mSession.commit();
            }
            catch (Exception anException)
            {
                anException.printStackTrace();
            }
        }

        return num;
    }


    /**
     * TODO: Documentation to be done for constructor 'MyBean', by 'vibh'..
     */
    public MyBean()
    {
        CreateInstance();
    }


    /**
     * @see com.jms.sample.IMyBean#produceMessage()
     */
    public int produceMessage (int PayloadInBytes)
    {
        Connection connection = null;
        Session session = null;
        MessageProducer publisher = null;
        Integer num=0;
        
        String payload = "";
        for(int i=0; i<PayloadInBytes; i++)
        {
            payload += "Z";            
        }

        try
        {
            InitialContext ic = new InitialContext();

            ConnectionFactory cf = (ConnectionFactory) ic.lookup("java:/JmsXA");
            Topic topic = (Topic) ic.lookup("topic/MyTopic");

            connection = cf.createConnection();
            session = connection.createSession(true, Session.SESSION_TRANSACTED);
            publisher = session.createProducer(topic);

            connection.start();

            num = getEventNumber();
            Message msg = session.createTextMessage(num.toString()+ ";" + payload);
            publisher.send(msg);
            //session.commit();
            // System.out.println("invoke");
            num--;
        }
        catch (Exception anException)
        {
            anException.printStackTrace();
        }
        finally
        {
            try
            {
                if (publisher != null)
                    publisher.close();

            }
            catch (JMSException anException)
            {
            }
            try
            {
                if (session != null)
                    session.close();

            }
            catch (JMSException anException)
            {
            }

            try
            {
                if (connection != null)
                    connection.close();

            }
            catch (JMSException anException)
            {
            }

        }
        
        return num;
    }


    /**
     * @see com.jms.sample.IMyBean#produceMessages()
     */
    @Override
    public int produce100Messages (int PayloadInBytes)
    {
        Connection connection = null;
        Session session = null;
        MessageProducer publisher = null;
        Integer num = 0;

        String payload = "";
        for(int i=0; i<PayloadInBytes; i++)
        {
            payload += "Z";            
        }
        
        try
        {
            InitialContext ic = new InitialContext();

            ConnectionFactory cf = (ConnectionFactory) ic.lookup("java:/JmsXA");
            Topic topic = (Topic) ic.lookup("topic/MyTopic");

            connection = cf.createConnection();
            session = connection.createSession(true, Session.SESSION_TRANSACTED);
            publisher = session.createProducer(topic);

            connection.start();

            num = getEventNumber();
            num = num * 100;
            for (int i = 0; i < 100; i++)
            {
                // if(i==95)
                // {
                // num++;
                // Message msg = session.createTextMessage(num.toString());
                // publisher.send(msg);
                // num--;
                // }
                
                //Message msg = session.createTextMessage(num.toString());
                Message msg = session.createTextMessage(num.toString()+ ";" + payload);
                
                publisher.send(msg);
                num++;
                //session.commit();
            }
            //session.commit();
            num--;
            // System.out.println("invoke");
        }
        catch (Exception anException)
        {
            anException.printStackTrace();
        }
        finally
        {
            try
            {
                if (publisher != null)
                    publisher.close();

            }
            catch (JMSException anException)
            {
            }
            try
            {
                if (session != null)
                    session.close();

            }
            catch (JMSException anException)
            {
            }

            try
            {
                if (connection != null)
                    connection.close();

            }
            catch (JMSException anException)
            {
            }

        }
        return num;
    }


    /**
     * @see com.jms.sample.IMyBean#produceMessagesUsingSingleton()
     */
    public int produce100MessagesUsingSingleton (int PayloadInBytes)
    {        
        return SendMessage(PayloadInBytes);
    }
}
