/**
 * Copyright (c) 2012 Barco n.v. All Rights Reserved. This software is confidential and proprietary information of Barco n.v. ("Confidential
 * Information"). You shall not disclose such Confidential Information and shall use it only in accordance with the terms of the license agreement you
 * entered into with Barco.
 */
package com.jms.sample;


import java.net.InetAddress;
import java.net.NetworkInterface;
import java.util.Enumeration;
import java.util.List;
import java.util.Properties;
import java.util.Set;
import java.util.TreeSet;

import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;

import org.jnp.interfaces.NamingContext;


/**
 * TODO: Documentation to be done for type 'MyJMSPublisher'..
 * 
 * @author vibh
 */
public class MyJMSPublisher
{
    static IMyBean bean;
    public static String URL;
    public static boolean IsBulk = false;
    public static boolean IsUseSingleton = false;
    public static int PayloadSize = 0;


    private static Object lookup (String aJNDIName)
        throws NamingException
    {
        System.out.println("Perform lookup on :: " + aJNDIName);

        Object service = null;

        // connect directly, if you are aware about active network
        if (mActiveNetworkAddress != null)
        {
            InitialContext context = getInitialContext();
            try
            {
                service = context.lookup(aJNDIName);
            }
            catch (NamingException e)
            {
                mLastKnownError = e;
                mActiveNetworkAddress = null;
                System.out.println("Unable to lookup: " + aJNDIName + "+ retrying other network interfaces..." + e);
            }
        }

        // check other network interfaces, in case of multi-lan env
        if (service == null)
        {
            service = lookupNW(aJNDIName);
            if (service == null)
            {
                System.out.println("Lookup failed on all network interfaces; Unable to lookup: " + aJNDIName + " on network interfaces "
                        + mNetworkInterfaceNameList + " [" + mLastKnownError.getClass() + ": " + mLastKnownError.getMessage() + "]");
                throw mLastKnownError;
            }
        }

        System.out.println("Lookup successful on: " + aJNDIName + " " + service);
        return service;
    }


    private static Object lookupNW (String aJNDIName)
    {
        Properties props = getContextProperties();

        Set<String> interfaceAddresses = getNetworkInterfaces();
        for (String address : interfaceAddresses)
        {
            System.out.println("Perform lookup: " + aJNDIName + " on network interface: " + address);
            props.put(NamingContext.JNP_LOCAL_ADDRESS, address);

            try
            {
                Object service = getInitialContext(props).lookup(aJNDIName);
                mActiveNetworkAddress = address;

                return service;
            }
            catch (NamingException e)
            {
                System.out.println("Unable to lookup: " + aJNDIName + " on network interface: " + address + e);
                mLastKnownError = e;

                continue;
            }
        }

        return null;
    }


    /**
     * Lookup context for getting server services
     * 
     * @return InitialContext
     * @throws NamingException
     */
    public static InitialContext getInitialContext ()
        throws NamingException
    {
        return new InitialContext(getContextProperties());
    }


    private static InitialContext getInitialContext (Properties props)
        throws NamingException
    {
        return new InitialContext(props);
    }


    private static Properties getContextProperties ()
    {
        final Properties props = new Properties();
        props.put(Context.INITIAL_CONTEXT_FACTORY, "org.jnp.interfaces.NamingContextFactory");
        props.put(Context.URL_PKG_PREFIXES, "org.jboss.naming:org.jnp.interfaces");
        // props.put("jnp.sotimeout", "2000");
        // props.put("jnp.timeout", "2000");
        props.put(Context.PROVIDER_URL, URL);


        // String partitionName = java.lang.System.getProperty("jboss.partition.name", java.lang.System.getenv("COMPUTERNAME") + "_PARTITION");
        // partitionName = "Jagan_MBeanTest_PARTITION";
        // partitionName = partitionName.toUpperCase();
        // System.out.println(partitionName);
        // props.put(NamingContext.JNP_PARTITION_NAME, partitionName);
        // // //
        // props.put(NamingContext.JNP_DISCOVERY_GROUP, "239.222.222.222");// Default
        // // props.put(NamingContext.JNP_DISCOVERY_PORT, "1102");// Default
        // // // props.put(NamingContext.JNP_DISCOVERY_TIMEOUT, "5000");// Default
        // // props.put(NamingContext.JNP_DISABLE_DISCOVERY, "false");


        return props;
    }
    private static String mActiveNetworkAddress;
    private static String mNetworkInterfaceNameList;
    private static NamingException mLastKnownError;


    /**
     * This method returns the set of netword interfaces.
     * 
     * @return {@link List} of netword interface Ip's
     */
    private static Set<String> getNetworkInterfaces ()
    {
        Set<String> interfaceAddresses = new TreeSet<String>();
        mNetworkInterfaceNameList = "[";

        Enumeration<NetworkInterface> networkInterfaces;
        try
        {
            networkInterfaces = NetworkInterface.getNetworkInterfaces();
            while (networkInterfaces.hasMoreElements())
            {
                NetworkInterface networkInterface = networkInterfaces.nextElement();

                if ((networkInterface.isUp()) && (networkInterface.getInetAddresses().hasMoreElements()) && (!networkInterface.isLoopback()))
                {
                    Enumeration<InetAddress> address = networkInterface.getInetAddresses();
                    while (address.hasMoreElements())
                    {
                        String networkIfc = address.nextElement().toString();
                        mNetworkInterfaceNameList += networkIfc + ",";

                        try
                        {
                            System.out.println("LookupNW -> Found network interface: " + networkIfc);

                            StringBuffer stringBuffer = new StringBuffer(networkIfc);
                            if (stringBuffer.indexOf("/") == 0)
                            {
                                stringBuffer.deleteCharAt(0);
                            }

                            interfaceAddresses.add(stringBuffer.toString());
                        }
                        catch (Exception e)
                        {
                            System.out.println("Unexpected exception occured while parsing network interface: " + networkIfc + e);
                        }
                    }
                }
            }
        }
        catch (Exception e)
        {
            System.out.println("Unexpected exception occured while listing network interfaces." + e);
        }
        mNetworkInterfaceNameList += "]";

        return interfaceAddresses;
    }


    /**
     * TODO: Documentation to be done for method 'main', by 'vibh'..
     * 
     * @param args
     * @throws Exception
     */
    public static void main (String[] args)
    {
        URL = args[0] + ":1099";
        System.out.println("URL = " + URL);
        IsBulk = (("BulkCall".equalsIgnoreCase(args[1])) ? true : false);
        IsUseSingleton = (("SingleSession".equalsIgnoreCase(args[2])) ? true : false);
        PayloadSize = Integer.parseInt(args[3]);


        try
        {
            reconnection();
        }
        catch (Exception anException)
        {
            try
            {
                try
                {
                    Thread.currentThread().sleep(2000);
                }
                catch (InterruptedException ie)
                {
                }

                reconnection();
            }
            catch (Exception anException1)
            {
                anException1.printStackTrace();
            }
        }
        
        try
        {
            Thread.currentThread().sleep(2000);
        }
        catch (InterruptedException anException)
        {

        }
    }
    
    public static int  makeCall (boolean isBulk, boolean isUseSingleton)
    {
        int ret = 0;
        try
        {
            if (isBulk)
            {
                if (isUseSingleton)
                {
                    ret = getMyBean().produce100MessagesUsingSingleton(PayloadSize);
                }
                else
                {
                    ret = getMyBean().produce100Messages(PayloadSize);
                }
            }
            else
            {
                for (int i = 0; i < 100; i++)
                {
                    ret = getMyBean().produceMessage(PayloadSize);
                }
            }
        }
        catch (Exception anException)
        {
            // TODO Auto-generated catch block
            anException.printStackTrace();
        }

        return ret;

    }


    private static void reconnection ()
        throws Exception
    {
        int counter = 0;
        while (true)
        {
            
            try
            {
                makeCall(IsBulk, IsUseSingleton);
 
                Thread.currentThread().sleep(1000);
                
                counter++;
                System.out.println("Calls " + counter );
                if(counter>=60)
                    break;
            }
            catch (InterruptedException anException)
            {
            }
            catch (Exception anException)
            {
                // anException.printStackTrace();
            }
        }
    }


    private static IMyBean getMyBean ()
        throws Exception
    {
        if (bean == null)
            bean = (IMyBean) lookup("MyBean/remote");
        return bean;
    }

}
