/**
 * Copyright (c) 2012 Barco n.v. All Rights Reserved. This software is confidential and proprietary information of Barco n.v. ("Confidential
 * Information"). You shall not disclose such Confidential Information and shall use it only in accordance with the terms of the license agreement you
 * entered into with Barco.
 */
package com.jms.sample;


import java.io.IOException;
import java.util.Properties;

import javax.jms.Connection;
import javax.jms.ConnectionFactory;
import javax.jms.ExceptionListener;
import javax.jms.JMSException;
import javax.jms.MessageConsumer;
import javax.jms.Session;
import javax.jms.TextMessage;
import javax.jms.Topic;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;



/**
 * TODO: Documentation to be done for type 'MyJMSSubscriber'..
 * 
 * @author vibh
 */
public class MyJMSSubscriber implements ExceptionListener
{
    private boolean mStop = false;
    
    public MsgListener mListener; 

    /**
     * TODO: Documentation to be done for method 'startSubscriber', by 'vibh'..
     */
    public void startSubscriber (String aServerName)
    {
        mListener = new MsgListener();
        String URL = aServerName + ":1100";
        try
        {
            final Properties props = new Properties();
            props.put(Context.INITIAL_CONTEXT_FACTORY, "org.jnp.interfaces.NamingContextFactory");
            props.put(Context.URL_PKG_PREFIXES, "org.jboss.naming:org.jnp.interfaces");
            // props.put(Context.PROVIDER_URL, "NOICLT22544:1100");
            props.put(Context.PROVIDER_URL, URL);

            InitialContext ic = new InitialContext(props);
            // IMyBean bean=(IMyBean) ic.lookup("MyBean/remote");

            ConnectionFactory cf = (ConnectionFactory) ic.lookup("/ConnectionFactory");
            Topic topic = (Topic) ic.lookup("topic/MyTopic");

            Connection connection = cf.createConnection();
            Session session = connection.createSession(false, Session.AUTO_ACKNOWLEDGE);
            MessageConsumer consumer = session.createConsumer(topic);

            connection.setExceptionListener(this);
            consumer.setMessageListener(mListener);

            connection.start();


            while (!mStop)
            {
                try
                {
                    connection.getClientID();
                    Thread.currentThread().sleep(200);
                }
                catch (InterruptedException anException)
                {

                }                
            }
        }
        catch (NamingException anException)
        {
            // TODO Auto-generated catch block
            anException.printStackTrace();
        }
        catch (Exception anException)
        {
            // TODO Auto-generated catch block
            anException.printStackTrace();
        }

        mListener.showResult();
        System.out.println("-----------------------");
    }
    
    /**
     * @see javax.jms.ExceptionListener#onException(javax.jms.JMSException)
     */
    @Override
    public void onException (JMSException anArg0)
    {
        // TODO Auto-generated method stub
        System.out.println("JMS Connection onExceptionListener-----");
        anArg0.printStackTrace();
        stopSubcriber();
    }


    /**
     * TODO: Documentation to be done for method 'stopSubcriber', by 'vibh'..
     * 
     */
    public void stopSubcriber ()
    {
        mStop = true;
    }


    /**
     * TODO: Documentation to be done for method 'main', by 'vibh'..
     * 
     * @param args
     */
    public static void main (String[] args)
    {
        
        final String Server = args[0];
        final MyJMSSubscriber subs = new MyJMSSubscriber();
        
        new Thread()
        {
            public void run()
            {
                subs.startSubscriber(Server);
            }
        }.start();
        
        try
        {
            System.in.read();
        }
        catch (IOException anException1)
        {
            // TODO Auto-generated catch block
            anException1.printStackTrace();
        }
        
        subs.stopSubcriber();
        
        try
        {
            Thread.currentThread().sleep(3000);
        }
        catch (InterruptedException anException)
        {
            // TODO Auto-generated catch block
            anException.printStackTrace();
        }
        
        
    }



}
